#include <iostream>

using namespace std;

int main()
{
    int a1[50000][2], n, m, mini = 0, maxi = 0, n1,n2, pom =0;
    cin >> n >> m;
    cin >> n1 >> n2;
    for(int i = 0; i < m; i++)
    {
        for(int j = 0; j<2; j++)
        {
            cin >> a1[i][j];
            if ( j == 0) mini += a1[i][j];
            else maxi += a1[i][j];
        }
    }
    for(int i = 0; i< m; i++)
    {
        a:
        if( pom == 1)break;
        while(a1[i][0] != a1[i][1])
        {
            a1[i][0]++;
            mini ++;
            if(mini == n1) {pom = 1; goto a;}
        }
    }
    for(int i = 0; i< m; i++)
    {
        cout << a1[i][0] << endl;
    }

}